program UTRA;

const AINT=256;
      BINT=65536;
      CINT=16777216;
{$I H:\REST\GEMCONST}
{ $I F:\PAS\COMPLIB\GEMCONST}

type BIOS_PAR_BLOCK=array[1..9] of integer;
     DISK_SEC=packed array[0..511] of byte;
     PBPB=^bios_par_block;
     PDS=^disk_sec;
     DATZEI=packed array[0..5] of char;
     CSTRING=packed array[0..255] of char;
     PATH=string[255];
     F_NAME=string[12];
     V=record a,c:integer;
              n:f_name;
              g:long_integer;
              d,t:datzei;
              ta:integer;
              r,u:^v;
       end;
     VPTR=^v;
{$I H:\REST\GEMTYPE}
{ $I F:\PAS\COMPLIB\GEMTYPE}
     
var FAT:packed array[0..32767] of byte;
    BUF:pds;
    ALLANF:vptr;
    BPB:pbpb;
    DMAP,DRIVE,ALTLW,ESDI,SPT,ANSE,ASI,ADI,BELSE,KAPSE,FREISE,BYERNO,
    ORDNER,FILES,ZEILES,ZEILEP,TAB,DIA,OFFSET,TAG,MON,JAH,STU,MIN,SEK,
    DUM,K,L,I:integer;
    AUSFUEHRBAR,IDIG,DRUCK,INF_PLUS,SUCH,ZAEHLEN:boolean;
    KAP,BELEGT,FREI,ACLOCK:long_integer;
    TOP:dialog_ptr;
    TOPE:array[0..31] of integer;
    LW:str255;
    GENMARK:^integer;
    r:real;

{$I H:\REST\GEMSUBS}
{ $I F:\PAS\COMPLIB\GEMSUBS}
{ procedure aus PASTRIX, also PASTRIX dazulinken ! }
PROCEDURE CtoPstr( Cstr : Cstring; Var Pstr : string ); EXTERNAL; 
PROCEDURE PtoCstr( Pstr : string; Var Cstr : Cstring ); EXTERNAL; 
PROCEDURE GetDate( Var Tag, Monat, Jahr : Integer); EXTERNAL; 
PROCEDURE GetTime( Var Stunde, Minute, Sekunde : Integer); EXTERNAL;
PROCEDURE Clear_home; EXTERNAL; 
PROCEDURE Inv_On; EXTERNAL; 
PROCEDURE Inv_Off; EXTERNAL; 
PROCEDURE Cur_right; EXTERNAL; 
PROCEDURE Cursor_home; EXTERNAL; 

{*** TOS-Stuff ***}  
function RWABS(flag:integer;buf:pds;count,recno,drive:integer):integer;
 BIOS(4);
function GETBPB(drive:integer):pbpb; BIOS(7);
function DRVMAP:integer; BIOS(10);
function CCONIN:char; GEMDOS(1);
function CRAWCIN:char; GEMDOS(7);
procedure SET_DRIVE(new_drive:integer);
var dum:integer;
function sdr(new_drive:integer):integer; GEMDOS(14);
{ Funktionswert ist Bloedsinn;
  drive: 0 = A:, 1 = B:, usw }
begin dum:=sdr(new_drive) end;
function CPRNOS:integer; GEMDOS(17);
function GET_DRIVE:integer; GEMDOS(25);                                               
{ Funktionswert: <0 = Fehler, 0 = A:, 1 = B:, usw }

{*** I/O-Stuff ***}
procedure EMPTY;
var c:char;
begin while keypress do c:=cconin; end;
procedure WARTE;
var c:char;
begin empty;c:=crawcin; end;
procedure BELL;
begin
 if druck then rewrite(output,'CON:');
 write(chr(7));
 if druck then rewrite(output,'PRN:');
end;
procedure PAUSE;
var k:integer;
    r:real;
begin bell;
 for k:=0 to 499 do r:=sin(r);
end;
procedure STARTPRINT;
var r:real;
    k:integer;
begin 
 while cprnos=0 do begin 
  writeln('                       ***** DRUCKER EINSCHALTEN *****');
  pause;
 end;
 rewrite(output,'PRN:');
 write(chr(27),'0',chr(15),chr(27),'l',chr(15)); {EPSON-FX80}
end;
procedure STOPPRINT;
begin rewrite(output,'CON:') end;
procedure CLMU;
begin hide_mouse;clear_home;zeiles:=0 end;
procedure CLMS;
begin clmu;show_mouse end;
procedure PAGE;
begin write(chr(12));zeilep:=0 end;

{*** Ausgabe ***}
procedure ZC;
begin 
 if druck then begin
  if zeilep=84 then page else zeilep:=zeilep+1;
 end else begin
  if zeiles=23 then begin warte;clms; end else zeiles:=zeiles+1;
 end;
end;

procedure GEMERROR;
begin bell;writeln;bell;rewrite(output,'CON:');
 writeln('##### SYSTEM-Fehler, GEM lsst sich nicht initialisieren #####');
 writeln('##### Programm bricht ab, ich empfehle den Affengriff    #####');
 warte;halt;
end;

procedure LW_ERROR;
begin bell;writeln;bell;rewrite(output,'CON:');
 writeln('##### Fehler: Laufwerk nicht vorhanden #####');
 writeln('##### Programm bricht ab !             #####');
 warte;halt;
end;

procedure ERSEC(n:integer;sw:boolean);
begin bell;writeln;bell;rewrite(output,'CON:');
 writeln('##### FEHLER:              #####');
 write('##### SECTOR ',n,' lsst sich nicht ');
 if sw then writeln('schreiben !') else writeln('lesen !');
 writeln('##### Programm bricht ab ! #####');
 warte;halt;
end;

procedure P_ANFANG(s,p:path);
begin clmu;
 if druck then startprint;
 zc;writeln(s,' ',chr(65+drive),':\',p);
end;

procedure P_SCHLUSS(ff:boolean);
begin zc;write(files,' Datei');
 if files<>1 then write('en');
 write(', ',ordner,' Ordner');
 if such then writeln else writeln(' mit insgesamt ',belegt,' Bytes');
 zc;writeln;
 if druck then begin
  if ff then page;
  stopprint
 end else warte;
 show_mouse;
end;
 
procedure P_FILE(n:f_name;a,c:integer;g:long_integer;date,time:datzei);
var i,j:integer;
begin zc;
 if not such then begin
  for i:=1 to tab do write(' ');
 end else bell;
 if not such and ((a & 16)=16) then write(tab div 2,'*');
 write(n);i:=length(n);
 while i<12 do begin write(' ');i:=i+1 end;
 write(a:3,g:8);
 if not such then begin write(' ',
       date[0],date[1],'.',date[2],date[3],'.',date[4],date[5],' ',
       time[0],time[1],':',time[2],time[3],':',time[4],time[5]);
  if inf_plus then begin writeln(' ',c);zc;
   for i:=1 to tab do write(' ');
   write('>');
   if odd(a & 1) then write(' nur-lesen');
   a:=shr(a,1); 
   if odd(a & 1) then write(' hidden');
   a:=shr(a,1); 
   if odd(a & 1) then write(' system');
   a:=shr(a,1); 
   if odd(a & 1) then write(' Diskname');
   a:=shr(a,1); 
   if odd(a & 1) then write(' Ordner');
   a:=shr(a,1); 
   if odd(a & 1) then write(' archiv');
   a:=shr(a,1); 
   if odd(a & 1) then write(' res6');
   a:=shr(a,1); 
   if odd(a & 1) then write(' res7');
  end;
 end;
 writeln;
end;

procedure PP_FILE(f:vptr);
begin tab:=f^.ta;p_file(f^.n,f^.a,f^.c,f^.g,f^.d,f^.t) end;

procedure P_SUBDIR(anf:vptr);
begin 
 while anf<>NIL do begin pp_file(anf);
  if anf^.u<>NIL then p_subdir(anf^.u);
  anf:=anf^.r;
 end;
end;

{*** Gewurstel mit Strings ***}
procedure TEILEFN(var a,n,e:f_name);
var k,l:integer;
begin k:=pos('.',a);l:=length(a);n:=a;e:=a;
 if k=0 then begin n:=a;e:='' end
 else begin delete(n,k,l-k+1);delete(e,1,k) end;
end;

function PASSTC(var a,s:f_name):boolean;
var l:integer;
    ok:boolean;
begin l:=length(a);ok:=l>0;
 while ok and (l>0) do begin 
  ok:=(s[l]='?') or (s[l]=a[l]);
  l:=l-1;
 end;
 passtc:=ok;
end;

function PASST(var a,n,e:f_name;fall:integer):boolean;
var v,h:f_name;
begin
 case fall of
  1:passt:=true;                                                    {*.*}
  2:begin teilefn(a,v,h);passt:=length(h)=0 end;                    {*.^}
  3:begin teilefn(a,v,h);passt:=passtc(h,e) end;                    {*.a}
  4:begin teilefn(a,v,h);passt:=length(v)=0 end;                    {^.*}
  5:passt:=length(a)=0;                                             {^.^}
  6:begin teilefn(a,v,h);passt:=(length(v)=0) and passtc(h,e) end;  {^.a}
  7:begin teilefn(a,v,h);passt:=passtc(v,n) end;                    {a.*}
  8:begin teilefn(a,v,h);passt:=(length(h)=0) and passtc(v,n) end;  {a.^}
  9:begin teilefn(a,v,h);passt:=passtc(v,n) and passtc(h,e) end;    {a.a}
 end;
end;

procedure GET_SEARCH_PARS(var a,n,e:f_name;var fall:integer);
begin teilefn(a,n,e);
 if n='*' then fall:=0
 else begin 
  if n='' then fall:=3
  else begin fall:=6;k:=length(n);
   if k>8 then delete(n,9,k-8);
   while k<8 do begin k:=k+1;insert('?',n,k) end;
  end;
 end;
 if e='*' then fall:=fall+1
 else begin
  if e='' then fall:=fall+2
  else begin fall:=fall+3;k:=length(e);
   if k>3 then delete(e,4,k-3);
   while k<3 do begin k:=k+1;insert('?',e,k) end;
  end;
 end;
end;

{ spaltet den ersten Ordner ab } 
procedure GET_F_FILE(var p:path;var f:f_name);
var i:integer;
    pa:path;
begin i:=pos('\',p);pa:=p;
 if i>0 then begin delete(p,1,i);f:=copy(pa,1,i-1) end
 else begin p:='';f:=pa end;
end;

{*** Sector-Gewhle, Umwandlungs-routinen ***}
{ erzeuge Datum aus integer }
procedure DATUM(var date:datzei;dd:integer);
var i:integer;
begin i:=dd & 31;dd:=shr(dd,5);
 date[0]:=chr(48+i div 10);date[1]:=chr(48+i mod 10);
 i:=dd & 15;dd:=shr(dd,4)+80;
 date[2]:=chr(48+i div 10);date[3]:=chr(48+i mod 10);
 date[4]:=chr(48+dd div 10);date[5]:=chr(48+dd mod 10);
end;

{ erzeuge Zeit aus integer }
procedure ZEIT(var time:datzei;dd:integer);
var i:integer;
begin i:=2*(dd & 31);dd:=shr(dd,5);
 time[4]:=chr(48+i div 10);time[5]:=chr(48+i mod 10);
 i:=dd & 63;dd:=shr(dd,6);
 time[2]:=chr(48+i div 10);time[3]:=chr(48+i mod 10);
 time[0]:=chr(48+dd div 10);time[1]:=chr(48+dd mod 10);
end;

procedure GET_BPB;
var p:pbpb;
begin {$P-} p:=getbpb(drive);bpb^:=p^; {$P+} end;

procedure READ_SEC(log_num:integer;buf:pds);
begin if rwabs(0,buf,1,log_num,drive)<>0 then ersec(log_num,false) end;

procedure WRITE_SEC(log_num:integer;buf:pds);
begin if rwabs(1,buf,1,log_num,drive)<>0 then ersec(log_num,true) end;

function GET_LOG_SEC(clu:integer):integer;
begin get_log_sec:=bpb^[7]+(clu-2)*2 end;

function GET_C_12(c:integer):long_integer;
var k:long_integer;
begin k:=c;k:=3*k div 2;
 if odd(c) then k:=(fat[k] & $F0) div 16 +16*fat[k+1]
 else k:=fat[k]+256*(fat[k+1] & $F);
 if (k>=$800) and (k<$FF0) then k:=1;
 if (k>=$FF0) and (k<$FF8) then k:=$0FFF0;
 if (k>=$FF8) and (k<$1000) then k:=$0FFFF;
 get_c_12:=k;
end;

function GET_C_16(c:integer):long_integer;
var k:long_integer;
begin k:=256;c:=c+c;k:=k*fat[c+1]+fat[c];
 if (k>=$08000) and (k<$0FFF0) then k:=1;
 if (k>=$0FFF0) and (k<$0FFF8) then k:=$0FFF0;
 if k>=$0FFF8 then k:=$0FFFF;
 get_c_16:=k;
end;

function LIES_FAT(stsec,anzsec:integer):boolean;
var cln:long_integer;
    k,l,i:integer;
begin byerno:=0;kapse:=0;belse:=0;l:=0;freise:=0;
 for k:=stsec to stsec+anzsec-1 do begin read_sec(k,buf);
  for i:=0 to 511 do fat[l+i]:=buf^[i];
  l:=l+512;
 end;
 k:=1;l:=adi div 2 +1;
 while (byerno=0) and (k<l) do begin k:=k+1;
  if bpb^[9]=0 then cln:=get_c_12(k) else cln:=get_c_16(k);
  if ((cln>1) and (cln<$0FFF0)) or (cln=$0FFFF) then belse:=belse+2
  else begin 
   if cln=1 then byerno:=k
   else begin 
    if cln=$0FFF0 then kapse:=kapse+2;
   end;
  end;
 end;
 lies_fat:=byerno=0;
end;

function GET_DISK_PAR:boolean;
var psum:long_integer;
    alstr:str255;
    k,i:integer;
begin set_drive(drive);read_sec(0,buf);get_bpb;
 esdi:=bpb^[5]+bpb^[6];spt:=buf^[24];anse:=buf^[26];
 asi:=buf^[19]+256*buf^[20];
 if spt<>0 then asi:=(asi div spt)*spt;
 adi:=(asi-bpb^[7]) div 2 *2;
 psum:=0;
 if drive<2 then begin
  for k:=0 to 255 do psum:=psum+buf^[2*k+1]+256*buf^[2*k];
 end;
 ausfuehrbar:=(psum & $0FFFF)=$1234;
 if ausfuehrbar then begin empty;
  alstr:=concat(
         '[3][     VORSICHT :         | der Bootsector auf| Laufwerk ',
         chr(65+drive),'| ist ausfhrbar !][kapiert]');      
  k:=do_alert(alstr,1);
 end;
 if lies_fat(bpb^[6],bpb^[5]) then get_disk_par:=true
 else begin writev(alstr,byerno);
  alstr:=concat('[3][VORSICHT: FAT 2 ist beschdigt|',
                'im Eintrag fr Cluster ',
                 alstr,'| |> ich lese FAT 1 !][na gut]');
  k:=do_alert(alstr,1);
  if lies_fat(1,bpb^[5]) then begin get_disk_par:=true;
   k:=do_alert(
     '[2][  Soll ich FAT 2 mit FAT 1 | |  BERSCHREIBEN ?][na gut|kusch]',0);
   if k=1 then begin l:=-512;
    for k:=bpb^[6] to bpb^[6]+bpb^[5] do begin l:=l+512;
     for i:=0 to 511 do buf^[i]:=fat[i+l];
     write_sec(k,buf);
    end;
   end;
  end else begin get_disk_par:=false;writev(alstr,byerno);
   alstr:=concat(
          '[3][MLL: FAT 1 ist auch hin !|Der Eintrag fr Cluster|',
          alstr,'|ist beschdigt !][rgern]');
   k:=do_alert(alstr,1);
  end;
 end;
 kap:=512;kap:=kap*asi;
 freise:=adi-bpb^[7]-belse-kapse;
 belegt:=512;belegt:=belegt*(asi-freise);
end;

{ alle Parameter besetzen }
function GET_FILE(n:integer;buf:pds;
                   var nam:f_name;var a,c:integer;
                   var g:long_integer;var date,time:datzei):boolean;
var w,i,j:integer;
begin w:=buf^[n];if w=229 then w:=0;
 if w>0 then begin a:=buf^[n+11];
  if (a & 16)=16 then g:=0
  else begin
   g:=buf^[n+29]*aint;if g<0 then g:=g+bint;
   g:=g+buf^[n+31]*cint+buf^[n+30]*bint+buf^[n+28];
  end;
  c:=buf^[n+26]+buf^[n+27]*256;
  if not zaehlen then begin j:=1;nam:='';
   for i:=n to n+7 do begin 
    if buf^[i]<>32 then begin insert(chr(buf^[i]),nam,j);j:=j+1 end;
   end;
   if buf^[n+8]+buf^[n+9]+buf^[n+10]<>96 then begin 
    insert('.',nam,j);j:=j+1;
   end;
   for i:=n+8 to n+10 do begin 
    if buf^[i]<>32 then begin insert(chr(buf^[i]),nam,j);j:=j+1 end;
   end;
   datum(date,buf^[n+24]+buf^[n+25]*256);
   zeit(time,buf^[n+22]+buf^[n+23]*256);
  end;
 end;
 get_file:=(w<>0);
end;

{ findet Ordner, gef = get_ordner>0, get_ordner=Cluster-Nr. }
function GET_ORDNER(n:integer;buf:pds;var nam:f_name):integer;
var w,a,i,j:integer;
begin nam:='';w:=buf^[n];if w=229 then w:=0;
 if w>0 then begin
  a:=buf^[n+11];
  if (a & 16)=16 then begin w:=buf^[n+26]+buf^[n+27]*256;j:=1;
   for i:=n to n+7 do begin 
    if buf^[i]<>32 then begin insert(chr(buf^[i]),nam,j);j:=j+1 end;
   end;
   if buf^[n+8]+buf^[n+9]+buf^[n+10]<>96 then begin 
    insert('.',nam,j);j:=j+1;
   end;
   for i:=n+8 to n+10 do begin 
    if buf^[i]<>32 then begin insert(chr(buf^[i]),nam,j);j:=j+1 end;
   end;
  end else w:=0;
 end;
 get_ordner:=w;
end;

function OSCAN_SEC(f:f_name;s:integer;stuv:boolean):integer;
var k,i:integer;
    fa:f_name;
begin read_sec(s,buf);i:=0;
 if stuv then k:=2 else k:=0;
 while (i=0) and (k<16) do begin i:=get_ordner(k*32,buf,fa);
  if fa<>f then i:=0;
  k:=k+1;
 end;
 oscan_sec:=i;
end;

{leg ein Bumchen an, ausser beim Zaehlen}
procedure MAKE_SUBDIR(var mutter:vptr;cl:integer);
var k,i,a,c,s,sp:integer;
    g,ll:long_integer;
    d,t:datzei;
    fa:f_name;
    gef,stuv:boolean;
    buf:pds;
    fbase,base:vptr;
begin mutter:=NIL;new(base);fbase:=base;
 new(buf);stuv:=cl>0;
 if cl=-1 then s:=esdi else begin s:=get_log_sec(cl);sp:=s+1 end;
 while cl<>0 do begin read_sec(s,buf);gef:=true;
  if stuv then k:=2 else k:=0;
  stuv:=false;
  while {gef and} (k<16) do begin gef:=get_file(k*32,buf,fa,a,c,g,d,t);
   if gef then begin 
    if not zaehlen then begin new(base^.r);base:=base^.r;
     base^.r:=NIL;base^.u:=NIL;
     if mutter=NIL then mutter:=base;
     base^.a:=a;base^.c:=c;base^.g:=g;base^.n:=fa;base^.d:=d;base^.t:=t;
     base^.ta:=tab;
    end;
    if (a & 16)=16 then begin ordner:=ordner+1;tab:=tab+2;
     make_subdir(base^.u,c);
    end
    else begin 
     if (a & 8)=0 then begin belegt:=belegt+g;files:=files+1 end;
    end;
   end;
   k:=k+1;
  end;
{  if gef then begin}
   if cl=-1 then begin 
    if s<esdi+bpb^[4]-1 then s:=s+1 else cl:=0; 
   end else begin
    if s=sp then begin 
     if bpb^[9]=0 then ll:=get_c_12(cl) else ll:=get_c_16(cl);
     if (ll>1) and (ll<$08000) then cl:=int(ll) else cl:=0;
    end else s:=s+1;
   end; 
{  end else cl:=0;}
 end;
 tab:=tab-2;
end;

{ p in der Form a.b\c.d\e.f  ...  Rckgabe: 0=nicht gef., sonst 1.Cluster
                                            oder -1=Directory }
function FINDE_PFAD(p:path):integer;
var cl,sec,k,l:integer;
    ll:long_integer;
    f:f_name;
    stuv:boolean;
begin 
 if p='' then cl:=-1 else begin cl:=0;
  get_f_file(p,f);k:=esdi;
  while (cl=0) and (k-esdi<bpb^[4]) do begin
   cl:=oscan_sec(f,k,false);k:=k+1;
  end;
  while (cl>0) and (p<>'') do begin get_f_file(p,f);stuv:=true;l:=1;
   while l>0 do begin k:=get_log_sec(cl);
    l:=oscan_sec(f,k,stuv);stuv:=false;
    if l=0 then l:=oscan_sec(f,k+1,false);
    if l=0 then begin
     if bpb^[9]=0 then ll:=get_c_12(cl) else ll:=get_c_16(cl);
     if (ll>1) and (ll<$08000) then l:=int(ll);
     cl:=l;
    end
    else begin cl:=l;l:=0 end;
   end;
  end;
 end;
 finde_pfad:=cl;
end;

{ Pfad reinziehen, 1. Cluster ansteuern 
  Rckgabe 0:nichts gef., -1:Wurzelverz., sonst: 1.Cluster }
function IN_PFAD(var p:path;var n:f_name;s:str255):integer;
var name:path;
    k,nin:integer;
begin nin:=0;name:='';p:=concat(chr(65+drive),':\*.*');n:='';
 text_heigth(13);
 clmu;
 draw_string(200,50,'Whle deinen Pfad aus:');
 draw_string(150,30,s);
 show_mouse;
 if get_in_file(p,name) then begin clms;k:=ord(p[1])-65;
  if (shl(1,k) & dmap)>0 then begin drive:=k;set_drive(k);
   if get_disk_par then begin
    delete(name,1,3);p:=name;k:=pos('\',name);
    while k>0 do begin delete(name,1,k);k:=pos('\',name) end;
    k:=length(name);n:=name;
    if k>0 then delete(p,length(p)-k+1,k);
    k:=length(p);
    if k>0 then delete(p,k,1);
    nin:=finde_pfad(p);
   end;
  end;
  files:=0;ordner:=0;belegt:=0;
  if nin=0 then begin text_heigth(26);
   draw_string(130,150,'Den Pfad gibt es nicht !');pause;
  end;
 end;
 clms;
 in_pfad:=nin;
end;

procedure SEARCH(start:vptr;n,e:f_name;fall:integer;p:path);
begin 
 while start<>NIL do begin
  if passt(start^.n,n,e,fall) then begin bell;write(p);pp_file(start);
   if (start^.a & 16)=16 then ordner:=ordner+1 else files:=files+1;
  end;
  if start^.u<>NIL then search(start^.u,n,e,fall,concat(p,start^.n,'\'));
  start:=start^.r;
 end;
end;


{***** Hauptteile *****}

procedure LW_INFO;
begin
 if get_disk_par then begin 
  if druck then startprint else clmu;
  zc;writeln('Laufwerk ',chr(drive+65),': ');
  if spt>0 then begin zc;
   if anse>0 then begin write(anse,' Seite');
    if anse<>0 then write('n');
    write(', ',asi div spt div anse,' Spuren, ');
   end;
   writeln(asi div spt,' Spuren insgesamt'); 
  end;
  zc;
  if spt>0 then write(spt,' Sektoren/Spur, ')
  else write('Festplatte ? , ');
  writeln(asi,' Sektoren insgesamt');
  zc;writeln('Erster Sektor FAT1: logische Nummer 1');
  zc;writeln('Erster Sektor FAT2: logische Nummer ',bpb^[6]);
  zc;writeln('Erster Sektor DIRECTORY: logische Nummer ',esdi);
  zc;writeln('Erster Datensektor : logische Nummer ',bpb^[7]);
  zc;writeln('Anzahl der Sektoren fuer Verwaltungskram: ',bpb^[7]);
  zc;writeln('Beschaedigte Sektoren: ',kapse);
  zc;writeln('Anzahl der Sektoren fuer Daten: ',adi-kapse);
  if spt>0 then begin zc;write('Der Bootsektor ist ');
   if not ausfuehrbar then write('nicht ');
   writeln('ausfuehrbar');
  end;
  zc;writeln;zc;
  writeln('Kapazitaet ',kap,' Bytes; davon ',kap-belegt,' Bytes frei, ',
          belegt,' Bytes belegt');
  zc;writeln;
  if druck then stopprint else warte;
  show_mouse;
 end;
end; 

procedure VERFOLGEN;
var p:path;
    fa,n:f_name;
    cl,fall,s,sp,a,c:integer;
    g,ll:long_integer;
    d,t:datzei;
    gef:boolean;
    cn:array[0..7] of integer;
begin cl:=in_pfad(p,n,'  > wir vefolgen eine Datei <');
 if cl<>0 then begin 
  if cl=-1 then begin s:=esdi;
   repeat read_sec(s,buf);k:=0;
    repeat
     if get_file(k*32,buf,fa,a,c,g,d,t) and (fa=n) then cl:=c;
     k:=k+1;
    until (cl>0) or (k>16);
    s:=s+1;
   until (cl>0) or (s=esdi+bpb^[4]);
  end 
  else begin 
   repeat s:=get_log_sec(cl);sp:=s+1;
    repeat read_sec(s,buf);k:=0;
     repeat gef:=get_file(k*32,buf,fa,a,c,g,d,t) and (fa=n);
      if gef then cl:=c;
      k:=k+1;
     until gef or (k>16);
     s:=s+1;
    until gef or (s>sp);
    if not gef then begin
     if bpb^[9]=0 then ll:=get_c_12(cl) else ll:=get_c_16(cl);
     if (ll>1) and (ll<$08000) then cl:=int(ll) else cl:=0;
    end;
   until gef or (cl=0);
  end;
  if cl>0 then begin k:=-1;
   p_anfang('Die Cluster einer Datei:',p);
   p_file(n,a,c,g,d,t);s:=0;
   repeat 
    if (k=7) or (cl=0) then begin 
     zc;write('Cluster: ');c:=0;a:=k;
     while a>=0 do begin write(cn[c]:5,'   ');c:=c+1;a:=a-1 end;
     writeln;zc;write('         ');c:=0;a:=k;
     while a>=0 do begin write('$',cn[c]:4:h,'   ');c:=c+1;a:=a-1 end;
     writeln;zc;writeln;
     zc;write('Sektor:  ');c:=0;a:=k;
     while a>=0 do begin write(get_log_sec(cn[c]):5,'   ');
      c:=c+1;a:=a-1;
     end;
     writeln;zc;write('         ');c:=0;
     while k>=0 do begin write('$',get_log_sec(cn[c]):4:h,'   ');
      c:=c+1;k:=k-1;
     end;
     writeln;zc;writeln;
     if cl=0 then cl:=-1;
    end
    else begin s:=s+1;k:=k+1;cn[k]:=cl;
     if bpb^[9]=0 then ll:=get_c_12(cl) else ll:=get_c_16(cl);
     if (ll>1) and (ll<$08000) then cl:=int(ll) else cl:=0;
    end;
   until cl=-1; 
   zc;writeln('insgesamt ',s,' Cluster belegt');zc;writeln;
   if druck then stopprint else warte;
  end
  else begin clmu;text_heigth(26);
   draw_string(130,150,'Die Datei gibt es nicht !');pause;
  end;
  show_mouse;
 end;
end;

procedure ZAEHLE_D;
var p:path;
    n:f_name;
    cl:integer;
begin mark(genmark);cl:=in_pfad(p,n,'     > wir zhlen Dateien <');
 if cl<>0 then begin make_subdir(allanf,cl);
  p_anfang('Anzahl der Dateien im Pfad:',p);
  p_schluss(false);
 end;
 release(genmark);
end;

procedure ANZEIGEN;
var p:path;
    n:f_name;
    cl:integer;
begin mark(genmark);cl:=in_pfad(p,n,'   > wir zeigen Dateien an <');
 if cl<>0 then begin make_subdir(allanf,cl);
  if allanf<>NIL then begin
   p_anfang('Die Dateien im Pfad:',p);
   p_subdir(allanf);
   p_schluss(true);
  end;
 end;
 release(genmark);
end;

procedure SUCH_PFAD;
var p:path;
    a,n,e:f_name;
    cl,fall:integer;
begin mark(genmark);cl:=in_pfad(p,a,'     > wir suchen Dateien <');
 if cl<>0 then begin make_subdir(allanf,cl);files:=0;ordner:=0;
  if allanf<>NIL then begin
   get_search_pars(a,n,e,fall);
   p_anfang('Gefundene Dateien im Pfad:',p);
   zc;writeln('Suchkriterium: ',a,'  Name:',n,'  Extension:',e);
   if cl>0 then p:=concat(p,'\');
   search(allanf,n,e,fall,p);
   p_schluss(false);
  end;
 end;
 release(genmark);
end;

procedure SUCH_ALLE;
var p:path;
    filespec,n,e:f_name;
    fall,k,l,i,zo,zf:integer;
    su:dialog_ptr;
    sui1,sui2,sui3:integer;
    ledit:str255;
begin clms;
 su:=new_dialog(2, 0,0, 27,5);
 sui1:=add_ditem(su,21,0,1,1,25,1,0,4480);
 set_dtext(su,sui1,'Gib einen Suchstring ein:',3,te_left);
 sui2:=add_ditem(su,29,8,1,3,12,1,0,4480);
 ledit:='';
 set_dedit(su,sui2,'____________','XXXXXXXXXXXXX',ledit,3,te_left);             
 sui3:=add_ditem(su,22,7,19,3,4,1,-3,4480);
 set_dtext(su,sui3,' ok ',3,te_left);
 center_dialog(su);
 k:=do_dialog(su,sui2);
 get_dedit(su,sui2,ledit);
 end_dialog(su);delete_dialog(su);
 k:=length(ledit);
 if k>12 then k:=12;
 filespec:='';
 while k>0 do begin l:=ord(ledit[k]);
  k:=k-1;
  if (l>96) and (l<123) then 
               insert(chr(l-32),filespec,1) else insert(chr(l),filespec,1);
 end;
 get_search_pars(filespec,n,e,fall);
 l:=dmap;zf:=0;zo:=0;
 clmu;
 if druck then startprint;
 zc;writeln('Alle Laufwerke:');
 zc;writeln('Suchkriterium: ',filespec,'  Name:',n,'  Extension:',e);
 for k:=0 to 15 do begin
  if (l & 1)=1 then begin mark(genmark);drive:=k;
   if get_disk_par then begin make_subdir(allanf,-1);
    if allanf<>NIL then begin ordner:=0;files:=0;
     search(allanf,n,e,fall,concat(chr(65+drive),':'));
     zo:=zo+ordner;zf:=zf+files;
    end;
   end;
   release(genmark);
  end;
  l:=shr(l,1);
 end;
 ordner:=zo;files:=zf;
 p_schluss(true);
end;

{*********** ANFANG SORTIEREN ************}
procedure SORTIEREN;
const MAXELEMENTS=150; {wieviele Elemente maximal ?}

type SORTFELD=array[1..maxelements] of vptr;

var p:path;
    n:f_name;
    cl,so:integer;

procedure QUICKMAX(var F:sortfeld; LL,RR:integer;
                   function ENT(a,b:vptr):integer);
const MASMAX=10; {bei weniger Elementen nur noch Maximumsort}
var HFELD:array[1..masmax] of vptr;
    MWERT:vptr;
    L,R,K,I:integer;

 procedure TAUSCHE(var f:sortfeld;k,l:integer);
 var TAUSCH:vptr;
 begin tausch:=f[k];f[k]:=f[l];f[l]:=tausch; end;

begin l:=ll;r:=rr;
 if r-l<masmax then begin             {*** normaler Maximumsort ***}
  while l<r do begin k:=r;mwert:=f[r];
   for i:=l to r-1 do begin
    if ent(f[i],mwert)>0 then begin k:=i;mwert:=f[i] end;
   end;
   if k<>r then tausche(f,k,r);
   r:=r-1;
  end;
 end
 else begin                           {*** der Quicksort ***}
  k:=(l+r) div 2;      {wir berechnen einen Pseudomittelwert}
  mwert:=f[k];   
  while r>l do begin
   while ent(f[l],mwert)<0 do l:=l+1;
   while ent(f[r],mwert)>0 do r:=r-1;
   if l<r then begin tausche(f,l,r);l:=l+1;r:=r-1 end;
  end;
  quickmax(f,ll,l-1,ent);quickmax(f,l,rr,ent);
 end;
end;

procedure SORT_SUBDIR(base:vptr;function ENT(a,b:vptr):integer);
var sf:sortfeld;
    le,k:integer;
begin le:=0;
 while base<>NIL do begin le:=le+1;sf[le]:=base;base:=base^.r end;
 if le>0 then begin quickmax(sf,1,le,ent);
  for k:=1 to le do begin tab:=sf[k]^.ta;pp_file(sf[k]);
   if sf[k]^.u<>NIL then sort_subdir(sf[k]^.u,ent);
  end;
 end;
end;

function NNAME(a,b:vptr):integer;
var na,nb,ea,eb:f_name;
begin teilefn(a^.n,na,ea);teilefn(b^.n,nb,eb);
 if na=nb then begin
  if ea>eb then nname:=1 else begin
   if ea=eb then nname:=0 else nname:=-1;
  end;
 end else begin
  if na>nb then nname:=1 else nname:=-1; 
 end;
end;

function NEXTE(a,b:vptr):integer;
var na,nb,ea,eb:f_name;
begin teilefn(a^.n,na,ea);teilefn(b^.n,nb,eb);
 if ea=eb then begin
  if na>nb then nexte:=1 else begin
   if na=nb then nexte:=0 else nexte:=-1;
  end;
 end else begin
  if ea>eb then nexte:=1 else nexte:=-1; 
 end;
end;

function NGROESSE(a,b:vptr):integer;
begin
 if a^.g>b^.g then ngroesse:=1
 else begin 
  if a^.g=b^.g then ngroesse:=0 else ngroesse:=-1;
 end;
end;

begin mark(genmark);cl:=in_pfad(p,n,'   > wir sortieren Dateien <');
 if cl<>0 then begin make_subdir(allanf,cl);
  if allanf<>NIL then begin
   so:=do_alert(
       '[2][ Wie wird sortiert ? | |       nach:][ Name | Ext | Gre ]',1);
   p_anfang('Die Dateien sortiert, Pfad:',p);
   case so of
    1:sort_subdir(allanf,nname);
    2:sort_subdir(allanf,nexte);
    3:sort_subdir(allanf,ngroesse);
   end;
   p_schluss(true);
  end;
 end;
 release(genmark);
end; 
{******************* ENDE SORTIEREN ***********************}

function GET_NTOP(lw:integer):integer;
var k,l,m:integer;
begin l:=dmap;m:=-1;
 for k:=0 to lw do begin
  if (l & 1)=1 then m:=m+1;
  l:=shr(l,1);
 end;
 if m<0 then lw_error;
 get_ntop:=m+offset;
end;

function GET_LW(t:integer):integer;
var k,l:integer;
begin l:=dmap;k:=-1;t:=t+1;
 while (t>0) and (k<16) do begin
  if (l & 1)=1 then t:=t-1;
  l:=shr(l,1);k:=k+1;
 end;
 if k=16 then lw_error;
 get_lw:=k;
end;
  
procedure NORM(i:integer);
begin obj_setstate(top,tope[i],0,false) end;

procedure INVI(i:integer);
begin obj_setstate(top,tope[i],1,false) end;

begin if init_gem>=0 then begin init_mouse;aclock:=clock;empty;
 druck:=false;inf_plus:=false;clms;clmu;writeln;
 writeln(' Falls die Ausgabe des Programms anhlt (nach 1 Seite), kann durch');
 writeln(' drcken einer Taste weitergefahren werden...');
 warte;writeln;
 if clock-aclock>9 then begin
  write('    ');inv_on;
  writeln(' Gratulation - Du hast es schon begriffen !!! ');
  inv_off;
  for i:=0 to 1999 do r:=sin(r);
 end;

 dmap:=drvmap;new(bpb);new(buf);clear_home;

 top:=new_dialog(31, 0,0, 68,15);
 tope[0]:=add_ditem(top,21,0,2,1,11,1,0,4480);
 set_dtext(top,tope[0],'Laufwerke :',3,te_left);
 tope[1]:=add_ditem(top,21,0,35,5,21,1,0,4480);
 set_dtext(top,tope[1],'einer Datei verfolgen',3,te_left);
 tope[2]:=add_ditem(top,21,0,2,7,15,1,0,4480);
 set_dtext(top,tope[2],'Dateien im Pfad',3,te_left);
 tope[3]:=add_ditem(top,21,0,2,9,11,1,0,4480);
 set_dtext(top,tope[3],'Suche Datei',3,te_left);

 tope[4]:=add_ditem(top,22,5,60,1,6,1,-1,4480);
 set_dtext(top,tope[4],' ENDE ',3,te_left);

 tope[5]:=add_ditem(top,22,5,3,12,9,1,-2,4480);
 set_dtext(top,tope[5],' Monitor ',3,te_left);
 invi(5);
 tope[6]:=add_ditem(top,22,5,15,12,9,1,-2,4480);
 set_dtext(top,tope[6],' Drucker ',3,te_left);
 tope[7]:=add_ditem(top,22,5,35,12,13,1,-2,4480);
 set_dtext(top,tope[7],' Normal-Info ',3,te_left);
 invi(7);
 tope[8]:=add_ditem(top,22,5,51,12,14,1,-2,4480);
 set_dtext(top,tope[8],' Info De-Luxe ',3,te_left);

 tope[9]:=add_ditem(top,22,5,2,5,15,1,-3,4480);
 set_dtext(top,tope[9],' Laufwerk-Info ',3,te_left);
 tope[10]:=add_ditem(top,22,5,25,5,9,1,-3,4480);
 set_dtext(top,tope[10],' Cluster ',3,te_left);

 tope[11]:=add_ditem(top,22,5,19,7,8,1,-3,4480);
 set_dtext(top,tope[11],' zhlen ',3,te_left);
 tope[12]:=add_ditem(top,22,5,29,7,10,1,-3,4480);
 set_dtext(top,tope[12],' anzeigen ',3,te_left);
 tope[13]:=add_ditem(top,22,5,41,7,11,1,-3,4480);
 set_dtext(top,tope[13],' sortieren ',3,te_left);

 tope[14]:=add_ditem(top,22,5,15,9,9,1,-3,4480);
 set_dtext(top,tope[14],' im Pfad ',3,te_left);
 tope[15]:=add_ditem(top,22,5,26,9,9,1,-3,4480);
 set_dtext(top,tope[15],' berall ',3,te_left);

 offset:=16;
 drive:=get_drive;altlw:=drive;
 l:=dmap;k:=offset;lw:='';
 for i:=0 to 15 do begin 
  if (l & 1)=1 then begin lw:=chr(i+65);
   tope[k]:=add_ditem(top,22,5,2+4*i,3,3,1,-2,4480);
   set_dtext(top,tope[k],lw,3,te_center);
   if drive=i then invi(k);
   k:=k+1;
  end;
  l:=shr(l,1);
 end;
 if lw='' then lw_error;
 center_dialog(top);show_mouse;
 
 repeat clmu;
  frame_round_rect(40,40,559,319);
  text_style(16);text_heigth(26);
  draw_string(160,80,'Disk-Information :');
  text_heigth(13);draw_string(225,350,'C by MK   09.06.90');
  set_mouse(m_point_hand);show_mouse;

  if drive<>altlw then begin norm(get_ntop(altlw));
   invi(get_ntop(drive));altlw:=drive;
  end;

  repeat hide_mouse;cursor_home;writeln;cur_right;cur_right;
   frame_round_rect(5,14,627,20);getdate(tag,mon,jah);gettime(stu,min,sek);
   inv_on;
   write('   RAM: ',2*memavail,
         '   Heute : ',tag,'.',mon,'.',jah,'  ',stu,':');
   if min<10 then write('0');
   write(min,':');
   if sek<10 then write('0');
   writeln(sek,'   Programm aktiv: ',clock-aclock,' sec ');
   inv_off;
   show_mouse;
   dia:=do_dialog(top,0);
   idig:=(dia>=tope[offset]) or ((dia>tope[4]) and (dia<tope[9]));
   if idig then begin
    if dia=tope[5] then begin norm(6);druck:=false end;
    if dia=tope[6] then begin norm(5);druck:=true end;
    if dia=tope[7] then begin norm(8);inf_plus:=false end;
    if dia=tope[8] then begin norm(7);inf_plus:=true end;
    if dia>=tope[offset] then begin norm(get_ntop(altlw));
     drive:=get_lw(dia-tope[offset]);altlw:=drive;
    end;
   end;
  until not idig;
 
  such:=false;zaehlen:=false;tab:=0;
  if dia=tope[9] then begin norm(9);lw_info end;
  if dia=tope[10] then begin norm(10);verfolgen end;
  if dia=tope[11] then begin norm(11);zaehlen:=true;zaehle_d end;
  if dia=tope[12] then begin norm(12);anzeigen end;
  if dia=tope[13] then begin norm(13);sortieren end;
  if dia=tope[14] then begin norm(14);such:=true;such_pfad end;
  if dia=tope[15] then begin norm(15);such:=true;such_alle end;
  end_dialog(top);
  
 until dia=tope[4];  
 clmu;delete_dialog(top);init_mouse;
exit_gem;end else gemerror; end.
